; File:     Combo11.asm
; by:       Rui Loureiro
;===============================================================================================
;                           Ficheiros inc / GLB
;-----------------------------------------------------------------------------------------------
                            include Combo11.inc

DialogWnd       proto    :DWORD,:DWORD,:DWORD,:DWORD

COMBOSTYLE1    equ WS_CHILD+WS_VISIBLE+WS_VSCROLL+CBS_DROPDOWNLIST+CBS_AUTOHSCROLL+CBS_NOINTEGRALHEIGHT
COMBOSTYLE2    equ WS_CHILD+WS_VISIBLE+WS_VSCROLL+CBS_DROPDOWN  or CBS_AUTOHSCROLL+CBS_NOINTEGRALHEIGHT

COMBO_STYLE1    equ WS_CHILD+WS_BORDER+WS_VISIBLE+WS_TABSTOP+WS_VSCROLL+CBS_HASSTRINGS+CBS_DROPDOWN
COMBO_STYLE2    equ WS_CHILD+WS_BORDER+WS_VISIBLE+WS_TABSTOP+WS_VSCROLL+CBS_HASSTRINGS+CBS_DROPDOWN+CBS_OWNERDRAWFIXED 

COMBOBOXEX1 macro x, y, dx, dy, ID
            invoke CreateWindowEx, 0, addr _CombBoxClas32, NULL, COMBOSTYLE1,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox, eax
ENDM

COMBOBOXEX2 macro x, y, dx, dy, ID
            invoke CreateWindowEx, 0, addr _CombBoxClas32, NULL, COMBOSTYLE2,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox, eax
ENDM

COMBOBOX1   macro x, y, dx, dy, ID
; Doesnt work
;############
            invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr _CombBoxClas32, NULL, COMBO_STYLE1,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox, eax
ENDM

COMBOBOX2   macro x, y, dx, dy, ID
; Doesnt work
;############
            invoke CreateWindowEx, 0, addr _CombBoxClas32, NULL, COMBO_STYLE1,
                                   x,y,dx,dy, hWnd, ID, _hInstance, NULL
            mov    _hComboBox, eax
ENDM

FONTCOMBO       macro
                invoke  GetStockObject, DEFAULT_GUI_FONT
                ;mov     hFntDefGui,eax
                invoke  SendMessage, _hComboBox, WM_SETFONT, eax,1
ENDM

SETUPCOMBO      macro   Tbl
                push    esi
                mov     esi, offset Tbl
                mov     ecx, dword ptr [esi - 4]
                xor     ebx, ebx
@@:             push    ecx

                mov     _cbex._mask, CBEIF_TEXT
                mov     _cbex.iItem, -1         
                mov     eax, [esi + ebx*4]
                mov     _cbex.pszText, eax                

                mov     _cbex.cchTextMax, 20     ;0
                mov     _cbex.iImage,0
                mov     _cbex.iSelectedImage,0
                mov     _cbex.iOverlay,0
                mov     _cbex.iIndent,0
                mov     _cbex.lParam,0

                invoke  SendMessage, _hComboBox, CBEM_INSERTITEM, 0, addr _cbex
                pop     ecx
                add     ebx, 1
                sub     ecx, 1
                jnz     short @B

                invoke SendMessage, _hComboBox, CB_SETCURSEL, 0 ,0                
                mov    _hComboItem, 0
                pop     esi
ENDM
;-----------------------------------------------
COMA            macro
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
;---
invoke  CreateWindowEx,0,ADDR CN_ComboBoxEx,0,
        WS_CHILD or WS_VISIBLE or WS_VSCROLL or CBS_DROPDOWN or CBS_AUTOHSCROLL or CBS_NOINTEGRALHEIGHT,
        15,38,320,240, hWnd,1000, _hInstance,0
mov     hWndCBEx,eax
invoke  SendMessage,hWndCBEx,WM_SETFONT,hFntDefGui,1

mov     cbei._mask,CBEIF_TEXT
mov     cbei.iItem,-1
mov     ebx,0
mov     esi,OFFSET _TblString
CBExLoop:
mov     eax,[esi]
mov     cbei.pszText,eax
invoke  SendMessage,hWndCBEx,CBEM_INSERTITEM,0,ADDR cbei
add     esi,4
inc     ebx
cmp     ebx,_MaxTblString
jne     CBExLoop

invoke SendMessage,hWndCBEx,CB_SETCURSEL,0,0

ENDM


DIALOGBOX         MACRO  Name, Proc
    invoke  DialogBoxParam, _hInstance, addr Name, _hWnd, addr Proc, 0 
ENDM
;===============================================================================================
;                           Constantes e Estruturas
;----------------------------------------------------------------------------------------------
.const
IDC_NEWDIS1     equ 4000
                 

MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL
MAIN_EXTSTYLE    equ 300h
$ECRAWIDTH       equ 600
$ECRAHEIGHT      equ 300  
MAXSIZE          equ 260      
;  Data Section 
.data
;--------------------------------------------------------
hFntDefGui      dd 0
hWndCBEx        dd 0

;--------------------------------------------------------                                
align 4
CN_ComboBoxEx   db "ComboBoxEx32",0
_ComboBoxClass  db "COMBOBOX",0
_CombBoxClas32  db "ComboBoxEx32",0

_hComboBox      dd 0
_hComboItem     dd 0
;....................................................................................
_IconName    db 'TDIcon', 0
_MenuName    db 'Menu',0        ; Definido em rsrc.rc
_ClassName   db 'WinClass',0
_WindowName  db 'ComboBoxEx 1',0
_AlteraDis  db "AlteraDis", 0
; ----------------------------------------------------------------------------------------------
_Heading1     db 'Produto', 0

_String1      db "Item 1",0
_String2      db "Item 2",0
_String3      db "Item 3",0
_String4      db "Item 4",0
_String5      db "Item five",0
_String6      db "Item six",0
_String7      db "Item seven bla bla blu blu",0

_MaxTblString dd 7
_TblString    dd offset _String1
              dd offset _String2
              dd offset _String3
              dd offset _String4
              dd offset _String5
              dd offset _String6
              dd offset _String7

;-----------------------------------------

szProgramName db "Subclass Combobox",0
szAboutText   db "Subclassing the edit control in a combobox",0
;  Data? Section 
.data?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_x           dd ?
_y           dd ?

_icce        INITCOMMONCONTROLSEX <?>
_hInstance   dd ?
_hWnd        dd ?
_hdc         dd ?
_CaseChoose  dd ?

cbei         COMBOBOXEXITEM <>

_cbex        COMBOBOXEXITEM <?>
;_nm          NMHDR <?>
;------------------------
_hComboEdit  dd ?
_OldEditProc dd ?
;  Code Section 
.code
;---------------------------------------
start:      invoke    GetModuleHandle, NULL
            mov       _hInstance, eax

            mov       _icce.dwSize, sizeof INITCOMMONCONTROLSEX
            mov       _icce.dwICC, ICC_USEREX_CLASSES or ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES


            invoke    InitCommonControlsEx, ADDR _icce    

            invoke    WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
            
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAWIDTH
            shr     eax, 1
            mov     _x, eax
            invoke  GetSystemMetrics, SM_CXSCREEN
            sub     eax, $ECRAHEIGHT
            shr     eax, 1
            sub     eax, 80
            mov     _y, eax

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
        	mov   _wcx.hbrBackground, COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            invoke LoadIcon, hInst, offset _IconName     
            mov    _wcx.hIcon, eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela: WS_HSCROLL or WS_VSCROLL	
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   _x, _y, $ECRAWIDTH, $ECRAHEIGHT, 
                                   NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     
            
            invoke    GetDC, _hWnd
            mov       _hdc, eax

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd           
;################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu0_1                                       

                    DIALOGBOX _AlteraDis, DialogWnd
                                            
                case    IDM_SAIR                                       

                    invoke    SendMessage, hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CREATE
                je      _WM_CREATE
                
                cmp     eax, WM_NOTIFY
                je      _WM_NOTIFY
                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND

; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; -------------------------------------------------------------------------
_WM_NOTIFY:     mov     ebx, lParam 
                mov     eax,[ebx+0]
                cmp     eax, hWndCBEx
                jne     _EndProcA           ;WP_Return
;---
CBExBeginEdit:
                mov     eax,[ebx+8]
                cmp     eax,CBEN_BEGINEDIT
                jne     CBExEndEdit
                jmp     WP_Return0                              ; return 0 to allow edit
;---
CBExEndEdit:
                cmp     eax,CBEN_ENDEDIT                        ; NMCBEENDEDIT structure !
                jne     _EndProcA       ;WP_Return              ; be sure to understand that !

                mov     eax,0                                   ;
                cmp     [ebx+12],eax                            ; fChanged, 1=changed
                je      WP_Return1                              ; return 1 to abort edit
                
                mov     eax,CBENF_RETURN                        ; if <Return> insert new item
                cmp     [ebx+20+CBEMAXSTRLEN],eax
                jne     WP_Return1
                
    ;##################################
    invoke  MessageBeep, MB_ICONHAND
    ;##################################
    
                add     ebx,20
                mov     cbei.pszText,ebx                        ; pointer to new item text
                mov     cbei._mask,CBEIF_TEXT                   ; insert new item
                mov     cbei.iItem,-1                           ; at end of list
                invoke  SendMessage,hWndCBEx,CBEM_INSERTITEM,0,ADDR cbei
                ;jmp     WP_Return0                              ; return 0 to allow edit
                
WP_Return0:     mov     eax, 0
                ret
WP_Return1:     mov     eax, 1
                ret                
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE::
                COMA
                jmp        _EndProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
align 16
DialogWnd        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

             SWITCH  uMsg
             CASE    WM_INITDIALOG

                COMA
                
                invoke   SetDlgItemText, hWnd, IDC_NEWDIS1, addr _Heading1
                invoke   GetDlgItem, hWnd, IDC_NEWDIS1
		    invoke   SetFocus, eax

                mov     eax, TRUE
	          ret
                
             CASE    WM_CLOSE
                
_Quit:          invoke   EndDialog, hWnd, 0

                mov     eax, TRUE
	          ret
;.............................................................
             CASE    WM_NOTIFY

                mov     ebx, lParam             ;WP_lParam 
                mov     eax, [ebx+0]
                cmp     eax, hWndCBEx
                jne     _exit
;---
CBExBeginEdit:  
                mov     eax, [ebx+8]
                cmp     eax, CBEN_BEGINEDIT
                jne     CBExEndEdit
                jmp     WP_Return0              ; return 0 to allow edit
;---
CBExEndEdit:
                cmp     eax,CBEN_ENDEDIT        ; NMCBEENDEDIT structure !
                ;jne     WP_Return               ; be sure to understand that !

                ;jne     _exit                  ; <--- doesnt work ###############
                ;jne     WP_Return1             ; <--- doesnt work
                jne     WP_Return0              ; <--- doesnt work  ##############
                
                mov     eax,0                                   ;
                cmp     [ebx+12],eax                            ; fChanged, 1=changed
                je      WP_Return1                              ; return 1 to abort edit
                
                mov     eax, CBENF_RETURN                       ; if <Return> insert new item
                cmp     [ebx+20+CBEMAXSTRLEN], eax
                jne     WP_Return1

    ;##################################
    invoke  MessageBeep, MB_ICONHAND
    ;##################################
                
                add     ebx, 20
                mov     cbei.pszText,ebx                         ; pointer to new item text
                mov     cbei._mask, CBEIF_TEXT                   ; insert new item
                mov     cbei.iItem,-1                            ; at end of list
                invoke  SendMessage,hWndCBEx, CBEM_INSERTITEM, 0, ADDR cbei
                jmp     WP_Return0                               ; return 0 to allow edit

WP_Return0:     mov     eax, 0
                ret

WP_Return1:     mov     eax, 1
                ret                
;.............................................................
             CASE    WM_COMMAND

;------------------ComboBox--------------------------
                mov     edx, wParam
                shr     edx, 16
                switch  edx
                    ;case    CBN_SELENDOK
                        ;invoke  MessageBeep, MB_ICONHAND
                        ;invoke  MessageBeep, MB_ICONASTERISK               

                    case    CBN_SELCHANGE

                        invoke SendMessage, _hComboBox, CB_GETCURSEL, 0 ,0
                        cmp    eax, CB_ERR
                        je     short @F

                        mov    _hComboItem, eax
                        invoke  MessageBeep, MB_ICONASTERISK                        
@@:
                endsw
;------------------ComboBox-FIM-------------------------
                switch  wParam
                    case    IDC_CANCELA
                    
                        mov     _CaseChoose, 0
                        jmp     _Quit
                                        
                    case    IDC_ALTERA
                                                                           
                        mov     _CaseChoose, 1
                        jmp     _Quit

                    case    IDC_DELETE              

                        mov     _CaseChoose, 2
                        jmp     _Quit
;.......................................................
                endsw
             ENDSW

_exit:          mov     eax, FALSE
		    ret
DialogWnd       endp
; ###################################################
    end     start
